=== debian/changelog ===
virtio-forwarder (1.1.99.51-1~unstable) unstable; urgency=low
  * New upstream release
    - Remove dependency on DPDK RTE SDK scripts (Closes: #915417)
    - Switch libprotobuf-c0-dev Build-Depends to libprotobuf-c-dev (Closes: #906293)
 -- Frik Botha <frik.botha@netronome.com>  Fri, 21 Dec 2018 13:36:34 +0200
