=== debian/control ===
Source: virtio-forwarder
Maintainer: Frik Botha <frik.botha@netronome.com>
Section: net
Build-Depends: debhelper (>= 11~), python-minimal, protobuf-c-compiler, libprotobuf-c-dev, libzmq3-dev, protobuf-compiler, python3-sphinx, libnuma-dev, libdpdk-dev, libpcap-dev, libxen-dev, meson (>= 0.47~), pkg-config, systemd
Standards-Version: 4.1.4
Homepage: https://github.com/Netronome/virtio-forwarder
Priority: optional

Package: virtio-forwarder
Architecture: amd64 i386
Depends: ${misc:Depends}, ${shlibs:Depends}, dpdk, python, python-zmq, python-protobuf
Description: SR-IOV virtual function to virtio packet forwarder
 virtio-forwarder is a userspace networking application that forwards
 bi-directional traffic between SR-IOV virtual functions and virtio networking
 devices in QEMU virtual machines. virtio-forwarder implements a virtio backend
 driver using the DPDK’s vhost-user library and services designated VFs by
 means of the DPDK poll mode driver (PMD) mechanism.
